package com.css.simulation.resource.scheduler.infra.db.mysql.mapper;

import api.common.pojo.po.project.MultiSimulationProjectTaskRecordPO;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface MultiSimulationProjectTaskRecordMapper {
    @Insert("insert into multi_simulation_project_task_record (id,scene_id,project_id,task_body,status,sort) values" +
        "(#{id},#{sceneId},#{projectId},#{taskBody},0,#{sort})")
    int addMultiSimulationProjectTaskRecord(@Param("id") String id, @Param("sceneId") String sceneId, @Param("projectId") String projectId, @Param("taskBody") String taskBody, @Param("sort") Integer sort);

    @Update("update multi_simulation_project_task_record set status = #{status},deleted = #{deleted} " +
        "where id = #{taskId}")
    int updateMultiSimulationProjectTaskRecordStatus(@Param("status") Integer status, @Param("taskId") String taskId, @Param("deleted") Integer deleted);

    @Select("select id,project_id,scene_id,task_body,status,sort multi_simulation_project_task_record where project_id = #{projectId} and deleted = 0")
    List<MultiSimulationProjectTaskRecordPO> selectMultiSimulationProjectTaskRecordList(@Param("projectId") String projectId);

    @Select("select id,project_id,scene_id,task_body,status,sort multi_simulation_project_task_record where id = #{taskId} and deleted = 0")
    MultiSimulationProjectTaskRecordPO selectMultiSimulationProjectTaskRecordById(@Param("taskId") String taskId);

//    @Select("select * from multi_simulation_project where deleted = 0 " +
//        "and id = #{id}")
//    MultiSimulationProjectTaskRecordPO selectMultiSimulationTaskByTaskId(@Param("id") String id);
//
//    @Select("select * from multi_simulation_project where deleted = 0 " +
//        "and scene_id = #{sceneId}")
//    MultiSimulationProjectTaskRecordPO selectMultiSimulationTaskBySceneId(@Param("sceneId") String sceneId);
//
//    @Select("select * from multi_simulation_project where deleted = 0 " +
//        "and project_id = #{projectId} order by sort,create_time asc")
//    List<MultiSimulationProjectTaskRecordPO> selectMultiSimulationTaskProjectId(@Param("projectId") String projectId);

}
